//
//  ParseStore.m
//  PhotoThing
//
//  Created by Maneesh Goel on 8/24/12.
//  Copyright (c) 2012 Maneesh Goel. All rights reserved.
//

#import "ParseStore.h"
#import <Parse/Parse.h>

@implementation ParseStore
+(void)submitPhoto:(UIImage *)image {
    CGImageRef imageRef = image.CGImage;
    UIImage *fixedOrientation = [UIImage imageWithCGImage:imageRef scale:1.0 orientation:UIImageOrientationRight];
    
    NSData *imageData = UIImageJPEGRepresentation(fixedOrientation, 0.6f);
    CGRect rect = CGRectMake(0, 0, 330, 176);
    CGImageRef cellImageRef = CGImageCreateWithImageInRect([fixedOrientation CGImage], rect);
    UIImage *cellImage = [UIImage imageWithCGImage:cellImageRef scale:0.5 orientation:UIImageOrientationUp];
    NSData *tableCellData = UIImageJPEGRepresentation(cellImage, 0.05f);

    
    NSString *uniqueID = [self uniqueID];
    PFFile *imageFile = [PFFile fileWithName:uniqueID data:imageData];
    PFFile *tableCellFile = [PFFile fileWithName:uniqueID data:tableCellData];
    
    //establish connection to parse
    [imageFile saveInBackgroundWithBlock:^(BOOL succeeded, NSError *error) {
        if (!error) {
            PFObject *photo = [PFObject objectWithClassName:@"Photo"];
            [photo setObject:imageFile forKey:@"imageFile"];
            [photo setObject:uniqueID forKey:@"photoID"];
            PFObject *cellPhoto = [PFObject objectWithClassName:@"CellImage"];
            [cellPhoto setObject:tableCellFile forKey:@"cellImage"];
            [cellPhoto setObject:uniqueID forKey:@"cellPhotoID"];
            //save photo
            [photo saveInBackgroundWithBlock:^(BOOL succeeded, NSError *error) {
                if (!error) {
                    NSLog(@"photo success");
                } else {
                    NSLog(@"photo error, %@", error);
                }
            }];
            [cellPhoto saveInBackgroundWithBlock:^(BOOL succeeded, NSError *error) {
                if (!error) {
                    NSLog(@"cell success");
                } else {
                    NSLog(@"cell error, %@", error);
                }
            }];
        } else {
            NSLog(@"connection error: %@", error);
        }
    }];
}

+(NSString *)uniqueID {
    int unique = arc4random() % INT_MAX;
    return [NSString stringWithFormat:@"%d",unique];
}

+(NSArray *)getCellImages {
    PFQuery *query = [PFQuery queryWithClassName:@"CellImage"];
    return [query findObjects];
}

+(NSArray *)getPhotos {
    PFQuery *query = [PFQuery queryWithClassName:@"Photo"];
    return [query findObjects];
}

+(PFObject *)getPhotoWithName:(NSString *)name {
    PFQuery *query = [PFQuery queryWithClassName:@"Photo"];
    [query whereKey:@"photoID" equalTo:name];
    return [query getFirstObject];
}
@end
